﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Lists;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace PdfSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //Create a new PDF document.
            PdfDocument doc = new PdfDocument();
            //Add a page to the document.
            PdfPage page = doc.Pages.Add();

            //Set the font
            PdfFont font = new PdfStandardFont(PdfFontFamily.Courier, 12,PdfFontStyle.Bold);
            //Set the format for the text
            PdfStringFormat format = new PdfStringFormat();
            format.Alignment = PdfTextAlignment.Left;
           
            //Set the properties to paginate the text.
            PdfLayoutFormat layoutFormat = new PdfLayoutFormat();
            layoutFormat.Break = PdfLayoutBreakType.FitPage;
            layoutFormat.Layout = PdfLayoutType.Paginate;
            
            string text = "Company Name - Promotion Feedback / Innovation - RS Action Requested:";
            //Create a text element 
            PdfTextElement element = new PdfTextElement(text, font);
            element.Brush = PdfBrushes.Black;
            element.StringFormat = format;
            PdfLayoutResult result = element.Draw(page, new RectangleF(0, 0, page.GetClientSize().Width, page.GetClientSize().Height), layoutFormat);

        
            text = @"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit  esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.";
            font=new PdfStandardFont(PdfFontFamily.Courier,10);
            element = new PdfTextElement(text, font);
            element.Brush = PdfBrushes.Black;
            element.StringFormat = format;
            result = element.Draw(result.Page, new RectangleF(result.Bounds.X, result.Bounds.Bottom, page.GetClientSize().Width, page.GetClientSize().Height), layoutFormat);

            text = @"Company Name2 - Something:";
            font = new PdfStandardFont(PdfFontFamily.Courier, 12,PdfFontStyle.Bold);
            element = new PdfTextElement(text, font);
            element.Brush = PdfBrushes.Black;
            element.StringFormat = format;
            result = element.Draw(result.Page, new RectangleF(result.Bounds.X, result.Bounds.Bottom, page.GetClientSize().Width, page.GetClientSize().Height), layoutFormat);


            text = @"Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do";
            font = new PdfStandardFont(PdfFontFamily.Courier, 10);
            element = new PdfTextElement(text, font);
            element.Brush = PdfBrushes.Black;
            element.StringFormat = format;
            result = element.Draw(result.Page, new RectangleF(result.Bounds.X, result.Bounds.Bottom, page.GetClientSize().Width, page.GetClientSize().Height), layoutFormat);
            
            //Create Ordered list 
            PdfOrderedList list = new PdfOrderedList();
            list.Marker.Brush = PdfBrushes.Black;
            list.Indent = 20;            
            font = new PdfStandardFont(PdfFontFamily.Courier, 10);
            list.Font = font;
            list.StringFormat = format;
            //Add items
            list.Items.Add("eiusmod tempor incididunt ut ");
            list.Items.Add("labore et dolore magna aliqua");
            list.Items.Add("labore et dolore magna aliqua");
            list.Draw(result.Page, new RectangleF(result.Bounds.X, result.Bounds.Bottom, page.GetClientSize().Width, page.GetClientSize().Height),layoutFormat);
       

            MemoryStream ms=new MemoryStream();
            doc.Save(ms);
            doc.Close(true);
            Save(ms, "Output.pdf");
        
        }
        async void Save(Stream stream, string filename)
        {

            stream.Position = 0;

            FileSavePicker savePicker = new FileSavePicker();
            savePicker.DefaultFileExtension = ".pdf";
            savePicker.SuggestedFileName = filename;
            savePicker.FileTypeChoices.Add("Adobe PDF Document", new List<string>() { ".pdf" });
            StorageFile stFile = await savePicker.PickSaveFileAsync();
            if (stFile != null)
            {
                Windows.Storage.Streams.IRandomAccessStream fileStream = await stFile.OpenAsync(FileAccessMode.ReadWrite);
                Stream st = fileStream.AsStreamForWrite();
                st.SetLength(0);
                st.Write((stream as MemoryStream).ToArray(), 0, (int)stream.Length);
                st.Flush();
                st.Dispose();
                fileStream.Dispose();
                MessageDialog msgDialog = new MessageDialog("Do you want to view the Document?", "File has been created successfully.");
                UICommand yesCmd = new UICommand("Yes");
                msgDialog.Commands.Add(yesCmd);
                UICommand noCmd = new UICommand("No");
                msgDialog.Commands.Add(noCmd);
                IUICommand cmd = await msgDialog.ShowAsync();
                if (cmd == yesCmd)
                {
                    // Launch the retrieved file
                    bool success = await Windows.System.Launcher.LaunchFileAsync(stFile);
                }
            }
        }
    }
}
